/* 
  
 */
 var loading = false;
 var win = false;
 var n   = 0;
 var term = '';

function googlebarDisplayCheck() {
  var main = document.getElementById("main-window");
  var googlebar = document.getElementById("googlebar");

  if (main.hasAttribute("chromehidden") && (googlebar != null)) {
    if (main.getAttribute("chromehidden").indexOf("location") != -1) {
      googlebar.setAttribute("collapsed", "true");
      googlebar.setAttribute("hidden", "true");
    }
  }
}

function googlebarEscape(term) {
  // we need to handle both '/' and '+' specially
  term = escape(term);
  return term.replace(/\+/g,"%2B").replace(/\//g,"%2F");
}


function googlebarBuildURI(criteria) {
  var terms = criteria.split(" ");
  var uri = "";

  for (var i = 0; i < terms.length; i++) {
    if (i > 0) {
      uri += "+";
    }
    uri += googlebarEscape(terms[i]);
  }
  return uri;
}

 function googlebarSearch(mods) {
   win = window._content.document;
 	if(!loading) {
	googlebarClearTerms();
 	var critBox = document.getElementById("googlebarCriteria");
	googlebarAddTerm(critBox.value);
	var crit = googlebarBuildURI(critBox.value);
	dump("Critbox " + critBox + " and value " + crit + "\n");
	//if(crit.length == 0) {
	//	var clipboard = readFromClipboard();
	//	if(clipboard.length > 0) critBox.setAttribute("value", clipboard);
	//}
	switch(mods) {
	case "site":
		win.location = 'http://www.google.com/search?sourceid=mozclient&q=site:' + win.location.hostname + 
'+' + crit;
		break;
	case "backwards":
		win.location = 'http://www.google.com/search?sourceid=mozclient&q=link:' + win.location;
		break;
	case "similar":
		win.location = 'http://www.google.com/search?sourceid=mozclient&q=related:' + win.location;
		break;
 	case "translate":
		win.location = 'http://translate.google.com/translate?hl=en&sourceid=mozclient&u=' + win.location;
		break;
	case "cache":
win.location = 'http://www.google.com/search?q=cache:' + win.location;
		break;
	case "images":
			win.location = 'http://images.google.com/images?sourceid=mozclient&q=' + crit;
		break;
	case "groups":
			win.location = 'http://groups.google.com/groups?sourceid=mozclient&q=' + crit;
		break;
	case "directory":

			win.location = 'http://www.google.com/search?sourceid=mozclient&q=' + crit + '&cat=gwd/Top&sa=N&tab=gd';
		break;
	case "lucky":
			win.location = 'http://www.google.com/search?q=' + crit + '&btnI=I%27m+Feeling+Lucky';
		break;
case "USA":

			win.location = 'http://www.google.com/unclesam?restrict=unclesam&hl=en&q=' + crit;
		break;
case "Catalog":

			win.location = 'http://catalogs.google.com/catalogs?q=' + crit;
		break;
case "bsd":

			win.location = 'http://www.google.com/bsd?restrict=bsd&hl=en&q=' + crit;
		break;
case "microsoft":

			win.location = 'http://www.google.com/microsoft?hq=microsoft&restrict=microsoft&hl=en&q=' + crit;
		break;
case "mac":

			win.location = 'http://www.google.com/mac?restrict=mac&hl=en&q=' + crit;
		break;
case "linux":

			win.location = 'http://www.google.com/linux?restrict=linux&hl=en&q=' + crit;
		break;
case "news":

			win.location = 'http://news.google.com/news?as_q=' + crit;
		break;
	default:
		win.location = 'http://www.google.com/search?sourceid=mozclient&q=' + crit;
		break;
	}

	}
 }
 
  function googlebarFindTerms(criteria) {
   // quotes only matter when preceded by a space or a quote.
   var terms = new Array();

   var inQuote = false;
   var haveTerm = false;

   var index = 0;		// our current pointer
   var currPtr = 0;	// the start of the current term
   var prevChar = ' ';	// the char we last saw
	
   while (index < criteria.length) {
      var currChar = criteria.charAt(index);
		
      switch (currChar) {
      case ' ':
         if (!inQuote && haveTerm) {
            terms.push(criteria.substring(currPtr, index));
            haveTerm = false;
         }
         break;
      case '"':
         if (!inQuote) {
            if (haveTerm) {
               terms.push(criteria.substring(currPtr, index));
               haveTerm = false;
            }
            
	    if ((prevChar == ' ') || (prevChar == '"')) {
               inQuote = true;
            }
         } else {
            if (haveTerm) {
               terms.push(criteria.substring(currPtr, index));
               haveTerm = false;
               inQuote = false;
            }
         }
         break;
      default:
         if (!haveTerm) {
            haveTerm = true;
            currPtr = index;
         }
      }
      prevChar = currChar;
      index++;
   }
   
   if (haveTerm) {
      terms.push(criteria.substring(currPtr, index));
   }
   
   return terms;		
}

  function googlebarAddTerm(term) {
  		dump("Adding term " + term + "\n");
 		var myMenuItem = document.createElement("menuitem");
		myMenuItem.setAttribute("label", term);
		 var critBox = document.getElementById("googlebarCriteria");
		 critBox.childNodes.item(0).appendChild(myMenuItem);
		var mySearchTermBox = document.getElementById("googlebarSearchTerms");
		var myTerms = googlebarFindTerms(term);		
		var tempNode;
 		for(var i=0;i<myTerms.length;i++) {
			dump("Split found " + myTerms[i] + "\n");
			tempNode = document.createElement("text");
			tempNode.setAttribute("value", myTerms[i]);
			//tempNode.setAttribute("className", "googleBarSearchTerm");
			tempNode.className = "googleBarSearchTerm";
			tempNode.setAttribute("onclick", "googlebarFindInPage('" + myTerms[i] + "')");
			mySearchTermBox.appendChild(tempNode);
		}
 }
 
function googlebarClearTerms() {
   var termBox = document.getElementById("googlebarSearchTerms");
   for(var numTerms=termBox.childNodes.length; numTerms > 0; numTerms--) {
      termBox.removeChild(termBox.childNodes[0]);
   }		
}

 
 function googlebarUp() {
       if (win.location.protocol != "about:") {
	var aUrl = win.location;
	aUrl=aUrl.toString();
        aUrl = aUrl.substring(0, aUrl.substring(0, aUrl.length-1).lastIndexOf('/')+1);
        win.location.href = aUrl;
		}
 }
 
 function blockBubble(bool) {
 	if(bool) {
  	var temp=setTimeOut("blockBubble", 500);
	} else {
	loading = false;
	}
 }	

function GooglebarHideItem(event)
{
	var item = event.target;
	var googbutton = document.getElementById(item.getAttribute("googlebaritem"));
	googbutton.setAttribute("hidden",!item.getAttribute("checked"));
}



function googlebarFindInPage(str) {
	var txt, i, found;
	
	if (str == "")
		return false;

	if (!window._content.find(str))
		while(window._content.find(str, false, true))
			n++;
	else
		n++;
	if (n == 0) {
		 alert(str + " was not found on this page.");
		 dump("Not found " + window._content.location + "\n");
	}
	
	return false;
}


function doSearchHighLight()
{
  var sidebarSearchText= document.getElementById("googlebarCriteria");
  var count=0;
  DumpTN(window._content.document.documentElement);
  for (x=0;x<nl.length;x++)
  {
     if (nl.item(x).nodeType==3)
     {
        count++;
	nl.item(x).nodeValue="hello";
     }
  }
  sidebarSearchText.value=count;
  //window._content.document.location="http://www.slashdot.org";
}

